SystemOrganization addCategory: #'Twitter-Bootstrap-Seaside-Canvas-Tags'!
SystemOrganization addCategory: #'Twitter-Bootstrap-Seaside-Widgets-Components'!
SystemOrganization addCategory: #'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

WAUnorderedListTag subclass: #TWBSUnorderedListTag
	instanceVariableNames: 'navType stacked nav dropdownMenu breadcrumb pager thumbnails mediaList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Canvas-Tags'!

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:36'!
beBreadcrumb
	
	self breadcrumb: true
! !

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:34'!
beDropdownMenu

	self dropdownMenu: true! !

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:34'!
beList
	
	self navType: #list
! !

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:43'!
beMediaList

	self mediaList: true! !

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:35'!
beNav

	self nav: true! !

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:42'!
bePager
	
	self pager: true! !

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:35'!
bePills
	
	self navType: #pills
! !

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:35'!
beStacked
	
	self stacked: true! !

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:36'!
beTabs
	
	self navType: #tabs
! !

!TWBSUnorderedListTag methodsFor: 'actions' stamp: 'topa 11/23/2012 11:42'!
beThumbnails

	self thumbnails: true! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:37'!
breadcrumb
	^ breadcrumb! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:37'!
breadcrumb: anObject
	breadcrumb := anObject! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:37'!
dropdownMenu

	^ dropdownMenu! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:33'!
dropdownMenu: anObject
	dropdownMenu := anObject! !

!TWBSUnorderedListTag methodsFor: 'testing' stamp: 'topa 11/23/2012 11:38'!
isBreadcrumb
	^ self breadcrumb ifNil: [false]! !

!TWBSUnorderedListTag methodsFor: 'testing' stamp: 'topa 11/23/2012 11:37'!
isDropdownMenu
	^ self dropdownMenu ifNil: [false]! !

!TWBSUnorderedListTag methodsFor: 'testing' stamp: 'topa 11/23/2012 11:44'!
isMediaList

	^ self mediaList ifNil: [false]! !

!TWBSUnorderedListTag methodsFor: 'testing' stamp: 'topa 11/23/2012 11:37'!
isNav
	^ self nav ifNil: [false]! !

!TWBSUnorderedListTag methodsFor: 'testing' stamp: 'topa 11/23/2012 11:41'!
isPager
	^ self pager ifNil: [false]! !

!TWBSUnorderedListTag methodsFor: 'testing' stamp: 'topa 11/23/2012 11:38'!
isStacked
	^ self stacked ifNil: [false]! !

!TWBSUnorderedListTag methodsFor: 'testing' stamp: 'topa 11/23/2012 11:42'!
isThumbnails

	^ self thumbnails ifNil: [false]! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:43'!
mediaList
	^ mediaList! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:43'!
mediaList: anObject
	mediaList := anObject! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:37'!
nav
	^ nav! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:27'!
nav: anObject
	nav := anObject! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:37'!
navType
	^ navType! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:27'!
navType: anObject
	navType := anObject! !

!TWBSUnorderedListTag methodsFor: 'private' stamp: 'topa 11/23/2012 11:58'!
openTag

	self isNav ifTrue: [
		self class: 'nav'.
		self navType ifNotNil: [
			self class: ('nav-' copyWithAll: self navType)	].
		self class: 'nav-stacked' if: self isStacked].
	self 
		class: 'dropdown-menu' if: self isDropdownMenu;
		class: 'breadcrumb' if: self isBreadcrumb;
		class: 'pager' if: self isPager;
		class: 'thumbnails' if: self isThumbnails;
		class: 'media-list' if: self isMediaList;
		yourself.
	
	super openTag.! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:39'!
pager
	^ pager! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:39'!
pager: anObject
	pager := anObject! !

!TWBSUnorderedListTag methodsFor: 'private' stamp: 'topa 11/22/2012 20:48'!
renderListItem: anObject labelled: aString
	canvas listItem
		class: 'active' if: (self isSelected: anObject);
		with: [
			self hasCallback
				ifFalse: [ canvas render: aString ]
				ifTrue: [
					canvas anchor
						callback: [ self performCallback: anObject ];
						with: aString ] ]! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:37'!
stacked
	^ stacked! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:27'!
stacked: anObject
	stacked := anObject! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:41'!
thumbnails
	^ thumbnails! !

!TWBSUnorderedListTag methodsFor: 'accessing' stamp: 'topa 11/23/2012 11:41'!
thumbnails: anObject
	thumbnails := anObject! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:49'!
twbsBreadcrumb

	^ self twbsUnorderedList 
		beBreadcrumb! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:49'!
twbsBreadcrumb: content

	self twbsBreadcrumb
		with: content! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:29'!
twbsContainer
	^ self div
		class: 'container'! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 10:52'!
twbsContainer: aBlock
	self twbsContainer
		with: aBlock
! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:05'!
twbsContainerFluid
	^ self div
		class: 'container-fluid'! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:05'!
twbsContainerFluid: aBlock
	self twbsContainerFluid
		with: aBlock
! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:48'!
twbsDropdownMenu

	^ self twbsUnorderedList 
		beDropdownMenu! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:48'!
twbsDropdownMenu: content
	
	self twbsDropdownMenu 
		with: content
! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:00'!
twbsHeroUnit

	^ self div class: 'hero-unit'! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:01'!
twbsHeroUnit: aValuable

	self twbsHeroUnit 
		with: aValuable! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 10:59'!
twbsIcon: aString
	"
	Note: Twitter Bootstrap recommends <i>, which is semantically incorrect.
	As the actual tag does not matter at all, we use the more applicable <span>.
	"
	self span
		class: ('icon-' copyWithAll: aString)! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 10:59'!
twbsIconWhite: aString
	"
	Note: Twitter Bootstrap recommends <i>, which is semantically incorrect.
	As the actual tag does not matter at all, we use the more applicable <span>.
	"
	self span
		class: (String streamContents: [:s | s 
			nextPutAll: 'icon-';
			nextPutAll: aString;
			nextPut: Character space;
			 nextPutAll: 'icon-white'])! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:51'!
twbsMediaList

	^ self twbsUnorderedList 
		beMediaList! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:51'!
twbsMediaList: content

	self twbsMediaList
		with: content! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:47'!
twbsNav

	^ self twbsUnorderedList 
		beNav! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:12'!
twbsNav: content

	^ self twbsNav
		with: content
! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/22/2012 10:31'!
twbsPageHeader
	^ self div
		class: 'page-header'! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 10:52'!
twbsPageHeader: aBlock
	self twbsPageHeader
		with: aBlock! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:50'!
twbsPager

	^ self twbsUnorderedList 
		bePager! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:50'!
twbsPager: content

	self twbsPager
		with: content! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/20/2012 14:05'!
twbsRow
	^ self div
		class: 'row'! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 10:52'!
twbsRow: aBlock
	self twbsRow
		with: aBlock
! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:30'!
twbsRowFluid
	^ self div
		class: 'row-fluid'! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:30'!
twbsRowFluid: aBlock
	self div
		class: 'row-fluid';
		with: aBlock
! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:30'!
twbsSpan: spanWidth
	^ self div
		class: 'span', spanWidth greaseString! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:06'!
twbsSpan: spanWidth with: aBlock
	^ (self twbsSpan: spanWidth)
		with: aBlock! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:50'!
twbsThumbnails

	^ self twbsUnorderedList 
		beThumbnails! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:51'!
twbsThumbnails: content

	self twbsThumbnails
		with: content! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'topa 11/23/2012 11:47'!
twbsUnorderedList 

	^ self brush: TWBSUnorderedListTag new
	! !

!WAAnchorTag methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/20/2012 15:35'!
twbsDataToggleDropDown
	self attributes at: 'data-toggle' put: 'dropdown'! !

!WAAnchorTag methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/20/2012 15:29'!
twbsDataTogglePill
	self attributes at: 'data-toggle' put: 'pill'! !

!WAAnchorTag methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/20/2012 15:29'!
twbsDataToggleTab
	self attributes at: 'data-toggle' put: 'tab'! !

WAMessageDecoration subclass: #TWBSErrorMessageDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!TWBSErrorMessageDecoration methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 07:40'!
renderContentOn: html
	html div
		class: 'alert';
		class: 'alert-error';
		with: message.
	self renderNextOn: html! !

WAMessageDecoration subclass: #TWBSInfoMessageDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!TWBSInfoMessageDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 20:40'!
renderContentOn: html
	html div
		class: 'alert';
		class: 'alert-info';
		with: message.
	self renderNextOn: html! !

WAMessageDecoration subclass: #TWBSSuccessMessageDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!TWBSSuccessMessageDecoration methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 07:40'!
renderContentOn: html
	html div
		class: 'alert';
		class: 'alert-success';
		with: message.
	self renderNextOn: html! !

WAFormDecoration subclass: #TWBSFormDecoration
	instanceVariableNames: 'formCss legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!TWBSFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:50'!
beHorizontal
	formCss := 'form-horizontal'! !

!TWBSFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:50'!
beInline
	formCss := 'form-inline'! !

!TWBSFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:50'!
beSearch
	formCss := 'form-search'! !

!TWBSFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:50'!
beVertical
	formCss := 'form-vertical'! !

!TWBSFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:50'!
formCss
	^ formCss! !

!TWBSFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:51'!
formCss: anObject
	formCss := anObject! !

!TWBSFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:51'!
initialize

	super initialize.
	self beVertical.! !

!TWBSFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:51'!
legend
	^ legend! !

!TWBSFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:51'!
legend: anObject
	legend := anObject! !

!TWBSFormDecoration methodsFor: 'rendering' stamp: 'topa 11/23/2012 00:49'!
renderButtonsOn: html
	html div 
		class: 'form-actions'; 
		class: self formCss;
		with: [
			self buttons 
				do: [ :each |
					html button
						accessKey: each value first;
						class: 'btn';
						class: 'btn-primary' if: (each = buttons first);
						text: each;
						on: each of: self decoratedComponent ]
				separatedBy: [ html text: ' ' ] ]! !

!TWBSFormDecoration methodsFor: 'rendering' stamp: 'topa 11/23/2012 00:56'!
renderContentOn: html
	html form
		class: self formCss;
		multipart: self requiresMultipartForm;
		defaultAction: [ self defaultAction ];
		with: [
			html fieldSet: [
				self renderLegendOn: html.
				self renderNextOn: html.
				self renderButtonsOn: html ] ]! !

!TWBSFormDecoration methodsFor: 'rendering' stamp: 'topa 11/23/2012 00:51'!
renderLegendOn: html
	self legend notNil ifTrue: [
		html legend: self legend ]! !

!WAFormInputTag methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/19/2012 13:45'!
twbsPlaceholderText: placeholderText
	self attributes at: 'placeholder' put: placeholderText! !

WAFormDialog subclass: #TWBSFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Components'!

!TWBSFormDialog methodsFor: 'actions' stamp: 'NickAger 3/21/2012 21:19'!
addForm
	form := TWBSFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!TWBSFormDialog methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 19:14'!
renderContentOn: html
	html hiddenInput 
		callback: [ validationError := nil ].
	validationError isNil
		ifFalse: [ self renderValidationError: validationError on: html ]! !

!TWBSFormDialog methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 19:08'!
renderValidationError: aString on: html
	html div
		class: 'alert';
		class: 'alert-error';
		with: aString! !

TWBSFormDialog subclass: #TWBSYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Components'!

!TWBSYesOrNoDialog methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 19:13'!
buttons
	^ #(yes no)! !

!TWBSYesOrNoDialog methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 19:13'!
no
	self answer: false! !

!TWBSYesOrNoDialog methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 19:13'!
yes
	self answer: true! !

WAWidgetDecoration subclass: #TWBSBootstrapDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!TWBSBootstrapDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/26/2012 10:17'!
renderContentOn: html

	html twbsContainer: [
		html twbsRow: [
			self renderNextOn: html]]! !

!TWBSBootstrapDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/26/2012 10:12'!
updateRoot: aHtmlRoot

	super updateRoot: aHtmlRoot.

	self requestContext response
		headerAt: 'X-UA-Compatible' put: 'IE=edge,chrome=1'.
	aHtmlRoot beHtml5.
	aHtmlRoot headElements copy do: [:ea | 
		(ea isKindOf: WAMetaElement) ifTrue: [aHtmlRoot headElements remove: ea]].
	(aHtmlRoot htmlAttributes)
		removeKey: 'xmlns';
		removeKey: 'xml:lang'.
	aHtmlRoot if lessThan; ie: '9';
 		do: [aHtmlRoot script beJavascript; url: 'http://html5shim.googlecode.com/svn/trunk/html5.js'].

		! !

WAComponent subclass: #TWBSTabWidget
	instanceVariableNames: 'tabs selectedTab columnSpan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Components'!

!TWBSTabWidget methodsFor: 'configuration' stamp: 'NickAger 9/1/2012 16:45'!
addTabWithTitle: title component: component
	self addTabWithTitle: title component: component columnSpan: 12! !

!TWBSTabWidget methodsFor: 'configuration' stamp: 'NickAger 9/1/2012 16:44'!
addTabWithTitle: title component: component columnSpan: aColumnSpan
	| tabInfo |
	tabInfo := TWBSTabInfo title: title component: component columnSpan: aColumnSpan.
	self tabs add: tabInfo! !

!TWBSTabWidget methodsFor: 'hooks' stamp: 'NickAger 9/1/2012 17:26'!
children
	^ self tabs collect: [ :each | each component ]! !

!TWBSTabWidget methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:46'!
columnSpan
	^ columnSpan ifNil: [ columnSpan := 12 ]! !

!TWBSTabWidget methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:45'!
columnSpan: anObject
	columnSpan := anObject! !

!TWBSTabWidget methodsFor: 'rendering' stamp: 'NickAger 9/1/2012 11:38'!
renderContentOn: html
	self renderJavascriptTabSwitcherOn: html.
	self renderTabUIOn: html.
	self renderTabContentOn: html! !

!TWBSTabWidget methodsFor: 'rendering' stamp: 'NickAger 9/1/2012 17:05'!
renderJavascriptTabSwitcherOn: html
	html document addLoadScript: 
		"hook into a twitter bootstrap 'shown' custom event  
		see *Twitter Bootstrap Togglable tabs>http://twitter.github.com/bootstrap/javascript.html#tabs*"
		((html jQuery: 'a[data-toggle="tab"]') on: 'shown' do: 
			(html jQuery post 
				callback: [ :hrefUrl | | url selectedIndex |
					"url will be of the form:
					     'http://localhost:8080/twitterbootstrap/tabdemo#2
					the fragment at the end gives the index into the tabs collection"
					url := WAUrl absolute: hrefUrl.
					selectedIndex := url fragment asInteger.
					self selectedTab: (self tabs at: selectedIndex)]
				value: (JSStream on: 'arguments[0].target.href'))) ! !

!TWBSTabWidget methodsFor: 'rendering' stamp: 'NickAger 9/1/2012 17:03'!
renderTabContentOn: html
	html twbsRow: [
		html div
			class: 'tab-content';
			with: [
				self tabs keysAndValuesDo: [ :index :each  |
					html div
						class: 'tab-pane';
						class: 'active' if: each = self selectedTab;
						id: index;
						with: [
							html twbsSpan: each columnSpan with: each component ] ] ] ]! !

!TWBSTabWidget methodsFor: 'rendering' stamp: 'NickAger 9/1/2012 16:54'!
renderTabUIOn: html
	html twbsRow: [
		html twbsSpan: self columnSpan with: [
			html unorderedList
				class: 'nav';
				class: 'nav-tabs';
				with: [
					self tabs keysAndValuesDo: [ :index :each  |
						html listItem
							class: 'active' if: each = self selectedTab;
							with: [
								html anchor
									url: '#', index asString;
									twbsDataToggleTab;
									with: each title ] ] ] ] ]! !

!TWBSTabWidget methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:46'!
selectedTab
	^ selectedTab ifNil: [ selectedTab := self tabs first ]! !

!TWBSTabWidget methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 11:37'!
selectedTab: anObject
	selectedTab := anObject! !

!TWBSTabWidget methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:51'!
tabs
	^ tabs ifNil: [ tabs := OrderedCollection new ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:18'!
twbsAddErrorMessage: aStringOrRenderingBlock
	"Add a decoration that displays a twsb info alert with aString around the receiver. Answer the decoration, so don't forget #yourself."
	
	^ self addDecoration: (TWBSErrorMessageDecoration new message: aStringOrRenderingBlock; yourself)! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:18'!
twbsAddInfoMessage: aStringOrRenderingBlock
	"Add a decoration that displays a twsb info alert with aString around the receiver. Answer the decoration, so don't forget #yourself."
	
	^ self addDecoration: (TWBSInfoMessageDecoration new message: aStringOrRenderingBlock; yourself)! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsAddSuccessMessage: aStringOrRenderingBlock
	"Add a decoration that displays a twsb info alert with aString around the receiver. Answer the decoration, so don't forget #yourself."
	
	^ self addDecoration: (TWBSSuccessMessageDecoration new message: aStringOrRenderingBlock; yourself)! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsConfirmError: aStringOrRenderingBlock
	"Display a yes/no dialog with caption aString. Answer true if the response is yes, false if no."

	^ self wait: [ :cc | self twbsConfirmError: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsConfirmError: aStringOrRenderingBlock onAnswer: aBlock
	"Display a yes/no dialog with caption aString. Evaluate aBlock passing in true if the response is yes, false if no."

	self
		call: (TWBSYesOrNoDialog new
			twbsAddErrorMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsConfirmInfo: aStringOrRenderingBlock
	"Display a yes/no dialog with caption aString. Answer true if the response is yes, false if no."

	^ self wait: [ :cc | self twbsConfirmInfo: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsConfirmInfo: aStringOrRenderingBlock onAnswer: aBlock
	"Display a yes/no dialog with caption aString. Evaluate aBlock passing in true if the response is yes, false if no."

	self
		call: (TWBSYesOrNoDialog new
			twbsAddInfoMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsConfirmSuccess: aStringOrRenderingBlock
	"Display a yes/no dialog with caption aString. Answer true if the response is yes, false if no."

	^ self wait: [ :cc | self twbsConfirmSuccess: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsConfirmSuccess: aStringOrRenderingBlock onAnswer: aBlock
	"Display a yes/no dialog with caption aString. Evaluate aBlock passing in true if the response is yes, false if no."

	self
		call: (TWBSYesOrNoDialog new
			twbsAddSuccessMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInform: aStringOrRenderingBlock
	"Display a dialog with aString to the user until he clicks the ok button."

	^ self wait: [ :cc | self twbsInform: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInform: aStringOrRenderingBlock onAnswer: aBlock	
	"Display a dialog with aString to the user until he clicks the ok button. Continue by evaluating aBlock."

	self 
		call: (TWBSFormDialog new
			twbsAddInfoMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInformError: aStringOrRenderingBlock
	"Display a dialog with aString to the user until he clicks the ok button."

	^ self wait: [ :cc | self twbsInformError: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInformError: aStringOrRenderingBlock onAnswer: aBlock	
	"Display a dialog with aString to the user until he clicks the ok button. Continue by evaluating aBlock."

	self 
		call: (TWBSFormDialog new
			twbsAddErrorMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInformSuccess: aStringOrRenderingBlock
	"Display a dialog with aString to the user until he clicks the ok button."

	^ self wait: [ :cc | self twbsInformSuccess: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:21'!
twbsInformSuccess: aStringOrRenderingBlock onAnswer: aBlock	
	"Display a dialog with aString to the user until he clicks the ok button. Continue by evaluating aBlock."

	self 
		call: (TWBSFormDialog new
			twbsAddSuccessMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

Object subclass: #TWBSTabInfo
	instanceVariableNames: 'title component columnSpan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Components'!

!TWBSTabInfo class methodsFor: 'instance creation' stamp: 'NickAger 9/1/2012 16:38'!
title: title component: component columnSpan: columnSpan
	^ self new
		title: title;
		component: component;
		columnSpan: columnSpan;
		yourself! !

!TWBSTabInfo methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:35'!
columnSpan
	^ columnSpan! !

!TWBSTabInfo methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:35'!
columnSpan: anObject
	columnSpan := anObject! !

!TWBSTabInfo methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:33'!
component
	^ component! !

!TWBSTabInfo methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:33'!
component: anObject
	component := anObject! !

!TWBSTabInfo methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:33'!
title
	^ title! !

!TWBSTabInfo methodsFor: 'accessing' stamp: 'NickAger 9/1/2012 16:33'!
title: anObject
	title := anObject! !
